<template>
  <div class="i3-container">
    <back></back>
    <h1 class="i3-page-title">Select a Preset</h1>
    <div v-for="(preset, key) in presets" :key="key">
      <input type="radio" :id="key" :value="key" v-model="selectedPreset" @click="selectPreset(key)">
      <label :for="key">{{ preset.name }}</label>
    </div>

    <button @click="pushPage('new-node-form-category', {}, 'New ' + contentTypes[contentType])" class="i3-next" :disabled="!selectedPreset">Next</button>
    <!-- <li v-for="(name, key) in contentTypes" @click="pushPage(nextComponent(key), { contentType: key }, 'New ' + name)">{{ name }}</li> -->
    <!-- [[ PRESETS ]] -->
    <!-- <pre>{{ contentTypes }}</pre> -->
    <!-- <li @click="pushPage('starting-point-category', {}, 'Starting Point')">Starting Point Category</li> -->
  </div>
</template>

<script>
import _ from 'lodash'

import { EDITABLE_NODE_PRESETS } from '@/components/Editable/config'

import { mapActions, mapGetters } from 'vuex'
import Back from '@/components/Editable/Utils/Back'

export default {
  components: {
    Back
  },

  props: {
    contentType: {
      type: String,
      required: true
    }
  },

  data () {
    return {
      selectedPreset: null,
      pushOnce: true
    }
  },

  computed: {
    ...mapGetters({
      backPageTitle: 'Y3TI/backPageTitle',
      contentTypes: 'Y3TI/contentTypes',
      routing: 'Y3TI/routing'
    }),

    presets () {
      return EDITABLE_NODE_PRESETS[this.contentType] || {}
    }
  },

  methods: {
    ...mapActions({
      pushSidebarPage: 'Y3TI/pushSidebarPage',
      backSidebarPage: 'Y3TI/backSidebarPage',
      getContentTypes: 'Y3TI/getContentTypes'
    }),

    pushPage (component, props, title) {
      return this.pushSidebarPage({ data: { page: { component, props, title } } })
    },

    backPage () {
      return this.backSidebarPage()
    },

    selectPreset (preset) {
      this.$router[this.pushOnce ? 'push' : 'replace']({ name: 'NewPresetNode-' + _.get(this.routing, ['definition', this.contentType, 'layout'], ''), params: { contentType: this.contentType, preset, keepSidebar: true }, hash: window.location.hash })
      this.pushOnce = false
      // this.$router.push({ name: 'NewPresetNode', params: { contentType: this.contentType, preset, keepSidebar: true } })
    }
    // nextComponent (key) {
    //   return _.isEmpty(EDITABLE_NODE_PRESETS[key]) ? 'new-node-form-category' : 'new-node-presets-category'
    // }
  },

  created () {
    this.getContentTypes({ options: { lazy: true } })
  }
}
</script>
